/*
    config.h

    Configuration file for VUCAKO Bench

    $Rev: 93 $
    $Date: 2007-03-17 16:25:56 +0100 (so, 17 III 2007) $

    Copyright (C) 2001-2007 by Josef Pelikan, MFF UK Prague
        http://cgg.ms.mff.cuni.cz/~pepca/

    VUCAKO Bench is Open Source software (see http://www.opensource.org/
    for description what Open Source is); you may distributed it and/or
    modify it under the terms of GNU General Public License as published
    by the Free Software Foundation; either version 2, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    A copy of the GNU General Public License is available as
    `/usr/doc/copyright/GPL' in the Debian GNU/Linux distribution or on
    the World Wide Web at http://www.gnu.org/copyleft/gpl.html.  You can
    also obtain it by writing to the Free Software Foundation, Inc., 59
    Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _CONFIG_H
#define _CONFIG_H

//  8-bit unsigned character (byte):
typedef unsigned char byte;
//  32-bit signed integer:
typedef int int32;
//  32-bit unsigned integer:
typedef unsigned unsigned32;

#ifdef USE_64_BITS
//  64-bit unsigned integer:
#  ifdef _MSC_VER
typedef unsigned __int64 unsigned64;
#  else
typedef unsigned long long unsigned64;
#  endif
#endif

//  "bool" type for old C++ compilers:
#ifdef NO_BOOL
typedef char bool;
#  define false ((char)0)
#  define true ((char)1)
#endif

//  Set next symbols according to your OS/architecture:
//#define WIN32                               // should be declared externally
#define BSD_COMPATIBLE                      // for Linux
#define FTIME

//-----------------------------------------------------------
//  Usually you don't have to edit anything below this line

#ifdef WIN32
#  include <windows.h>
#  define __CDECL __cdecl
#  define VIRTUAL_ALLOC(len)  VirtualAlloc(NULL,len,MEM_COMMIT,PAGE_READWRITE)
#  define VIRTUAL_FREE(a,len) VirtualFree(a,0,MEM_RELEASE)
#  define SLEEP(t)            SleepEx(t,FALSE)
#  define STRNICMP(a,b,c)     _strnicmp(a,b,c)
#else
#  define __CDECL
#  include <unistd.h>
#  include <endian.h>
#  define VIRTUAL_ALLOC(len)  (new char[len])
#  define VIRTUAL_FREE(a,len) (delete []a)
#  define SLEEP(t)            sleep((t)/1000)
#  define STRNICMP(a,b,c)     strncmp(a,b,c)
#  if __BYTE_ORDER == __BIG_ENDIAN
#    define HAVE_BIG_ENDIAN
#  endif
#endif

#define MinElapsed  20000

#ifdef _MSC_VER
#  pragma warning(disable:4005)
#  pragma warning(disable:4996)
#  define COMPILE_ASSERT(cond)  { char d[ (cond) ? 1 : -1 ]; (void)d; }
#else
#  define COMPILE_ASSERT(cond)  { char d[ (cond) ? 0 : -1 ]; (void)d; }
#endif

#ifdef __INTEL_COMPILER
#  pragma warning(disable:1786)
#endif

#endif
